/* CSE791 Course Project -- Jiangang Guo*/

#include < Xm/Xm.h> 
#include < Xm/Label.h>  
#include < Xm/Form.h> 
#include < Xm/PushB.h> 
#include < Xm/RowColumn.h> 
#include < Xm/CascadeB.h> 
#include < Xm/Scale.h> 
#include <Xm/Separator.h>

#define SCALE_INTENSITY_CB 1
#define SCALE_FOCUS_CB 2
 
XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;
 
Widget toplevel, form, menu_bar;
Widget scaleIntensity, labelIntensity, sepIntensity;
Widget scaleFocus, labelFocus, sepFocus;
Widget file_menu;
Widget open_item;
Widget close_item;
Widget quit_item;
Widget edit_menu;
Widget copy_item;
Widget cut_item;
Widget paste_item;
 
void menuCB(w,client_data,call_data)
    Widget w;
    char *client_data;
    XmAnyCallbackStruct *call_data;
/* callback routine used for all menus */
{
    printf("Content-type: text/html");
    printf("%s\n",client_data);
    if (strcmp(client_data,"Quit")==0) /* if quit seen, then exit */
       exit(0); 
} 
 
void scaleCB(w, client_data, call_data)
    Widget w;
    int client_data;
    XmScaleCallbackStruct *call_data;
/* handles the scales' callback. */
{   
    char s[100];
    Arg al[10];
    int ac;
 
    switch(client_data){
    case SCALE_INTENSITY_CB:
      sprintf(s,"light intensity=%d",call_data-> value*2);
      ac=0;
      XtSetArg(al[ac],XmNlabelString,
        XmStringCreate(s,char_set)); ac++;
        XtSetValues(labelIntensity,al,ac);
      break;
    case SCALE_FOCUS_CB:
      sprintf(s,"light focus=%d",call_data-> value*2);
      ac=0;
      XtSetArg(al[ac],XmNlabelString,
        XmStringCreate(s,char_set)); ac++;
        XtSetValues(labelFocus,al,ac);
      break;
    }
}

Widget make_menu_item(item_name,client_data,menu)
    char *item_name;
    caddr_t client_data;
    Widget menu;
/* adds an item into a menu. */ 
{
    int ac;
    Arg al[10];
    Widget item;
 
    ac = 0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreateLtoR(item_name,char_set)); ac++;  
    item=XmCreatePushButton(menu,item_name,al,ac);
    XtManageChild(item);
    XtAddCallback(item,XmNactivateCallback,menuCB,client_data);  
/*    XtSetSensitive(item,False); */
    XtSetSensitive(item,True);
    return(item);
}
 
Widget make_menu(menu_name,menu_bar)
    char *menu_name; 
    Widget menu_bar;
/* creates a menu on the menu bar */
{
    int ac;
    Arg al[10];
    Widget menu, cascade;
 
    menu=XmCreatePulldownMenu(menu_bar,menu_name,NULL,0);
    ac=0;
    XtSetArg (al[ac],XmNsubMenuId, menu); ac++;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreateLtoR(menu_name,char_set)); ac++;
    cascade=XmCreateCascadeButton(menu_bar,menu_name,al,ac);  
    XtManageChild(cascade); 
    return(menu);
}
 
void create_menus(menu_bar)
    Widget menu_bar;
/* creates all the menus for this program */
{
    /* create the file menu */
    file_menu=make_menu("File",menu_bar);
    open_item=make_menu_item("Open","Open selected",file_menu);
    close_item=make_menu_item("Close","Close selected",file_menu);
    quit_item=make_menu_item("Quit","Quit",file_menu);
 
    /* create the edit menu */
    edit_menu=make_menu("Edit",menu_bar);
    copy_item=make_menu_item("Copy","Copy selected",edit_menu);
    cut_item=make_menu_item("Cut","Cut Selected",edit_menu);
    paste_item=make_menu_item("Paste","Paste Selected",edit_menu);
}
 
void main(argc,argv)
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;
 
    /* create the toplevel shell */
    toplevel = XtAppInitialize(& context,"",NULL,0,
      & argc,argv,NULL,NULL,0);
 
    /* resize the window */
    ac=0;
    XtSetArg(al[ac],XmNheight,400); ac++;
    XtSetArg(al[ac],XmNwidth,400); ac++;
    XtSetValues(toplevel,al,ac);
 
    /* create a form widget */
    ac=0;
    form=XmCreateForm(toplevel,"form",al,ac);
    XtManageChild(form);
 
     /* create a scale for light intensity */
    ac=0;
    XtSetArg(al[ac],XmNtitleString,
        XmStringCreate("Relative Intensity",char_set)); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    XtSetArg(al[ac],XmNshowValue,True); ac++;
    scaleIntensity=XmCreateScale(form,"scaleIntensity",al,ac);
    XtManageChild(scaleIntensity);
    XtAddCallback(scaleIntensity,XmNdragCallback,scaleCB,SCALE_INTENSITY_CB);

    /* create a label light intensity */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("light intensity = 0",char_set)); ac++;
    labelIntensity=XmCreateLabel(form,"labelIntensity",al,ac);
    XtManageChild(labelIntensity);
 
    /* create a separator light intensity */
    ac=0;
    sepIntensity=XmCreateSeparator(form,"sepIntensity",al,ac);
    XtManageChild(sepIntensity);

     /* create a scale for light focus */
    ac=0;
    XtSetArg(al[ac],XmNtitleString,
        XmStringCreate("Relative Focus",char_set)); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    XtSetArg(al[ac],XmNshowValue,True); ac++;
    scaleFocus=XmCreateScale(form,"scaleFocus",al,ac);
    XtManageChild(scaleFocus);
    XtAddCallback(scaleFocus,XmNdragCallback,scaleCB,SCALE_FOCUS_CB);

    /* create a label light focus */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("light focus = 0",char_set)); ac++;
    labelFocus=XmCreateLabel(form,"labelFocus",al,ac);
    XtManageChild(labelFocus);
 
    /* create a separator light focus */
    ac=0;
    sepFocus=XmCreateSeparator(form,"sepFocus",al,ac);
    XtManageChild(sepFocus);

    /* create the menu bar */
    ac=0;
    menu_bar=XmCreateMenuBar(form,"menu_bar",al,ac);
    XtManageChild(menu_bar);

    /* attach the children to the form */
 
    /* attach the menu bar to the form */
    ac=0;
    XtSetArg(al[ac],XmNtopAttachment,XmATTACH_FORM); ac++;
    XtSetArg(al[ac],XmNrightAttachment,XmATTACH_FORM); ac++;
    XtSetArg(al[ac],XmNleftAttachment,XmATTACH_FORM); ac++;
    XtSetValues(menu_bar,al,ac);
 
    /* attach the scaleIntensity to the form */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, menu_bar); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition, 10); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition, 90); ac++; 
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++; 
    XtSetValues(scaleIntensity,al,ac);


    /* attach the labelIntensity to the form */
    ac=0;
    XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac],XmNtopWidget, scaleIntensity); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition, 10); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition, 90); ac++; 
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++; 
    XtSetValues(labelIntensity,al,ac);
 
    /* attach the sepIntensity to the form */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, labelIntensity); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetValues(sepIntensity,al,ac);

    /* attach the scaleFocus to the form */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, sepIntensity); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition, 10); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition, 90); ac++; 
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++; 
    XtSetValues(scaleFocus,al,ac);


    /* attach the labelFocus to the form */
    ac=0;
    XtSetArg(al[ac],XmNtopAttachment,XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac],XmNtopWidget, scaleFocus); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition, 10); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition, 90); ac++; 
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++; 
    XtSetValues(labelFocus,al,ac);
 
    /* attach the sepFocus to the form */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, labelFocus); ac++; 
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetValues(sepFocus,al,ac);

    create_menus(menu_bar);
 
    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
